
import java.io.IOException;
import java.util.Date;

public class EightQueens {
            static void log(String s) {
                        if (log)
                                    System.out.println(s);
            }

            static int log2(int i) {
                        int count = 0;
                        i--;
                        do {
                                    i = i / 2;
                                    count++;
                        } while (i > 0);
                        return count;
            }

            static int power2(int x) {
                        int count = 1;
                        for (int i = 0; i < x; i++)
                                    count *= 2;
                        return count;
            }

            static boolean threaded = false;
            static boolean first = false;
            static boolean log = false;
            static boolean print = false;
            static boolean wait = false;
            static boolean nocheck = false;
            static int size = 15;

            private static void parseParameters(String args[]) {
                        for (int i = 0; i < args.length; i++) {
                                    if (args[i].equalsIgnoreCase("threaded"))
                                                threaded = true;
                                    else if (args[i].equalsIgnoreCase("first"))
                                                first = true;
                                    else if (args[i].equalsIgnoreCase("log"))
                                                log = true;
                                    else if (args[i].equalsIgnoreCase("print"))
                                                print = true;
                                    else if (args[i].equalsIgnoreCase("wait"))
                                                wait = true;
                                    else if (args[i].equalsIgnoreCase("nocheck"))
                                                nocheck = true;
                                    else {
                                                try {
                                                            size = Integer.parseInt(args[i]);
                                                } catch (NumberFormatException e) {
                                                            System.out.println("Invalid argument:" + args[i]);
                                                }
                                    }

                                    if (first) {
                                                threaded = false;
                                                print = true;
                                    }
                        }
            }

            public static void main(String args[]) {
                        Date begin = new Date();
                        parseParameters(args);
                        System.out.println("" + size + " queens.");
                        System.out.println("Started at:" + begin);
                        int solution_size = (!threaded) ? Solution.solveSingle(size, first, ! nocheck)
                                                : Solution.solve(size, ! nocheck);
                        Date finish = new Date();
                        System.out.println("Finished at:" + finish + ", after "
                                                + (finish.getTime() - begin.getTime()) + " ms.");
                        System.out.println("" + solution_size + " solutions found.");
                        if (print)
                                    for (int i=0;i<solution_size;i++) {
                                                System.out.println(Desk.toString(Solution.solutions[i]));
                                    }
                        if (wait)
                                    try {
                                                System.in.read();

                                    } catch (IOException e) {
                                                e.printStackTrace();
                                    }
            }
}