class Dronning {
    public static void main(String args[]) {
	int n = 8;
	if (args.length > 0)
	    n = Integer.parseInt(args[0]);
	new Generate(n);
    }
}
 
class Generate {
    int p[];
    int n;
    int antall;
    boolean d1[], d2[];
    int trans[][];
 
    Generate(int n) {
	antall = 0;
	this.n = n;
	p = new int[n];
	d1 = new boolean[2*n - 1]; 
	d2 = new boolean[2*n - 1];
	trans = new int[7][n];
	for (int i = 0; i < n; i++) 
	    p[i] = i;
	
	long tid = System.currentTimeMillis();
	getPerm(0); 
	tid = System.currentTimeMillis() - tid;
 
	System.out.println();
	System.out.println("Time used: " + (tid/1000.0) + " seconds");
	System.out.println("Number of unique solutions with n=" + n + " : " + antall);
    }
 
    /**
     * Genererer permutasjoner
     **/
    void getPerm(int u) {
	boolean ledigDiag = ((!d1[u + p[u]]) && (!d2[(n-1) + u - p[u]]));
	if (u == n - 1 && ledigDiag) {                                  
	    boolean ubrukt = true;
	    for(int i = 0; i < n; i++) {
		trans[0][p[i]] = i; //diagonal 1
		trans[1][n-1-p[i]] = n-1-i; //diagonal 2
		trans[2][n-1-i] = p[i]; //horizontal
		trans[3][i] = n-1-p[i]; //vertical
		trans[4][n-1-p[i]] = i; //90 rotation
		trans[5][n-1-i] = n-1-p[i]; //180 rotation
		trans[6][p[i]] = n-1-i; //270 rotation
	    }
	    for (int k = 0; k < 7; k++) {           // 
		for (int y = 0; y < n; y++) {       // Check to see if it has
		    if (trans[k][y] < p[y]) {       // been counted before
			y = n;                      //
			k = 7;                      //
			ubrukt = false;             //
		    } else if (trans[k][y] > p[y])
			y = n;
		}
	    }
	    if (ubrukt) {
		antall++; //Counts the unique solutions
		//skriv() //Prints the solution
	    }
	} else {
	    if (ledigDiag) {
		d1[u + p[u]] = true;
		d2[(n-1) + u - p[u]] = true;
		getPerm(u+1);
		d1[u + p[u]] = false;
		d2[(n-1) + u - p[u]] = false;
	    }
	    int stop = 0;
	    if (u == 0) {    
		stop = n/2;  
	    } else {
		stop = n;
	    }
	    for (int i = u+1; i < stop; i++) {
		int tmp = p[u]; // Switches
		p[u] = p[i];    // the values
		p[i] = tmp;     // u and i.
		if ((!d1[u + p[u]]) && (!d2[(n-1) + u - p[u]])) {
		    d1[u + p[u]] = true;
		    d2[(n-1) + u - p[u]] = true;
		    getPerm(u+1);
		    d1[u + p[u]] = false;
		    d2[(n-1) + u - p[u]] = false;
		}
	    }
	    int tmp = p[u];
	    for (int k = u+1; k < n; k++) //Rotates the numbers from u to n-1 against left
		p[k-1] = p[k];
	    p[n-1] = tmp;
	}
    }
 
    void skriv() {
	for (int u = 0; u < n; u++)
	    System.out.print(p[u]);
	System.out.println();
    }
}